/*
	摜Cu gpwb_(depend.h)
*/

#ifndef DEPEND_H
#define DEPEND_H

#include <stdio.h>
#include "image.h"

#ifdef USE_UNISTD_H
#include <unistd.h>
#endif

#if defined(USE_WINDOWS_H) || defined(USE_VFW_H)
#include <windows.h>
#else
#define DWORD	uint32
#define WORD	uint16
#define BYTE	uint8

/* DIB t@Cwb_ */
typedef struct {
	WORD bfType;	/* "BM" */
	DWORD bfSize;	/* t@CTCY */
	WORD bfReserved1;	/* \(0) */
	WORD bfReserved2;	/* \(0) */
	DWORD bfOffBits;	/* C[Wf[^̃ItZbg */
} BITMAPFILEHEADER;

/* DIB wb_ */
typedef struct {
	DWORD biSize;	/* wb_TCY */
	DWORD biWidth;	/* 摜̑傫() */
	DWORD biHeight;	/* 摜̑傫(c) */
	WORD biPlanes;	/* (1) */
	WORD biBitCount;	/* 1f̃rbg(1, 4, 8, 24) */
	DWORD biCompression;	/* k` */
	DWORD biSizeImage;	/* k̃C[Wf[^̃TCY */
	DWORD biXPelsPerMeter;	/* 1m̉f() */
	DWORD biYPelsPerMeter;	/* 1m̉f(c) */
	DWORD biClrUsed;	/* gĂF̐ */
	DWORD biClrImportant;	/* gĂdvȐF̐ */
} BITMAPINFOHEADER;

/* DIB J[e[u */
typedef struct {
	BYTE rgbBlue;	/*  */
	BYTE rgbGreen;	/*  */
	BYTE rgbRed;	/*  */
	BYTE rgbReserved;	/* \(0) */
} RGBQUAD;

/* ` */
typedef struct {
	WORD left;
	WORD top;
	WORD right;
	WORD bottom;
} RECT;
#endif

#ifdef USE_VFW_H
#include <vfw.h>
#else
#define FOURCC	uint32

/* AVICwb_ */
typedef struct {
	DWORD dwMicroSecPerFrame;	/* 1t[̃}CNb */
	DWORD dwMaxBytesPerSec;	/* ߎő僌[g */
	DWORD dwPaddingGranularity;	/* ACgbyte */
	DWORD dwFlags;	/* AvP[VtO */
#define AVIF_HASINDEX	0x00000010	/* CfNX */
#define AVIF_MUSTUSEINDEX	0x00000020	/* CfNXKgp */
#define AVIF_ISINTERLEAVED	0x00000100	/* C^[[u */
#define AVIF_WASCAPTUREFILE	0x00010000	/* Lv` */
#define AVIF_COPYRIGHTED	0x00020000	/* 쌠ƂȂ */
#define AVIF_KNOWN_FLAGS	0x00030130	/* }XN */
	DWORD dwTotalFrames;	/* t[ */
	DWORD dwInitialFrames;	/* I[fBIL[ */
	DWORD dwStreams;	/* Xg[ */
	DWORD dwSuggestedBufferSize;	/* obt@TCY */
	DWORD dwWidth;	/* t[  */
	DWORD dwHeight;	/* t[  */
	DWORD dwReserved[4];	/* 0 */
} MainAVIHeader;

/* AVIXg[wb_ */
typedef struct {
	FOURCC fccType;	/* ^Cv */
	FOURCC fccHandler;	/* k` */
	DWORD dwFlags;	/* tO */
#define AVISTREAMINFO_DISABLED 0x00000001	/* Xg[̓_ */
#define AVISTREAMINFO_FORMATCHANGES 0x00010000	/* pbgύX܂ */
#if 0
	DWORD dwCaps;	/* @\tO */
#endif
	WORD wPriority;	/* D揇 */
	WORD wLanguage;	/*  */
	DWORD dwInitialFrames;
	DWORD dwScale;	/* ԒP */
	DWORD dwRate;	/* [g */
	DWORD dwStart;	/* ŏ̃t[̔ԍ */
	DWORD dwLength;	/* Xg[̒ */
	DWORD dwSuggestedBufferSize;	/* obt@TCY */
	DWORD dwQuality;	/*  */
	DWORD dwSampleSize;	/* 1̃f[^TṽTCY */
	RECT rcFrame;	/* \` */
} AVIStreamHeader;

/* AVI CfNX */
typedef struct {
	DWORD ckid;	/* `NID */
	DWORD dwFlags;	/* tO */
#define AVIIF_LIST	0x00000001	/* Xgł */
#define AVIIF_KEYFRAME	0x00000010	/* L[t[ł */
#define AVIIF_FIRSTPART	0x00000020
#define AVIIF_LASTPART	0x00000040
#define AVIIF_MIDPART	(AVIIF_LASTPART | AVIIF_FIRSTPART)
#define AVIIF_NOTIME	0x00000100
#define AVIIF_COMPUSE	0x0fff0000
#define AVIIF_KNOWN_FLAGS	0x0fff0171
	DWORD dwChunkOffset;	/* ItZbg */
	DWORD dwChunkLength;	/*  */
} AVIINDEXENTRY;
#endif

#ifdef USE_X
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#endif

/*
	}N
*/
#define FALSE	0	/* U */
#define TRUE	1	/* ^ */

/* 傫̒l߂ */
#define MAX(x, y)	((x) > (y) ? (x): (y))

/* 3̒l̂ő̂̂߂ */
#define MAX3(x, y, z)	((x) > (y) ? ((x) > (z) ? (x): (z)): ((y) > (z) ? (y): (z)))

/* ̒l߂ */
#define MIN(x, y)	((x) < (y) ? (x): (y))

/* 3̒l̂ŏ̂̂߂ */
#define MIN3(x, y, z)	((x) < (y) ? ((x) < (z) ? (x): (z)): ((y) < (z) ? (y): (z)))

/* Βl */
#define ABS(x)	((x) > 0 ? (x): -(x))

/* 2悷 */
#define POW2(x)	((x) * (x))

/* x  y ȉ̂Ƃ y, z ȏ̂Ƃ z, ȊÔƂ x ߂ */
#define MINMAX(x, y, z)	((x) > (y) ? ((x) < (z) ? (x): (z)): (y))

#ifndef O_BINARY
#define O_BINARY	0
#endif

/* fl */
#if defined(BYTEORDER_LITTLEENDIAN)
#	if defined(IMAGE_BGR)
		/* -RGB */
#		define PIX_BIT_A	24
#		define PIX_BIT_R	16
#		define PIX_BIT_G	8
#		define PIX_BIT_B	0
#	else
		/* -BGR */
#		define PIX_BIT_A	24
#		define PIX_BIT_B	16
#		define PIX_BIT_G	8
#		define PIX_BIT_R	0
#	endif
#elif defined(BYTEORDER_BIGENDIAN)
#	if defined(IMAGE_BGR)
		/* BGR- */
#		define PIX_BIT_B	24
#		define PIX_BIT_G	16
#		define PIX_BIT_R	8
#		define PIX_BIT_A	0
		/* RGB- */
#	else
#		define PIX_BIT_R	24
#		define PIX_BIT_G	16
#		define PIX_BIT_B	8
#		define PIX_BIT_A	0
#	endif
#elif defined(BYTEORDER_PDPENDIAN)
#	if defined(IMAGE_BGR)
		/* GB-R */
#		define PIX_BIT_B	16
#		define PIX_BIT_G	24
#		define PIX_BIT_A	8
#		define PIX_BIT_R	0
#	else
		/* RG-B */
#		define PIX_BIT_R	24
#		define PIX_BIT_G	16
#		define PIX_BIT_A	8
#		define PIX_BIT_B	0
#	endif
#endif

/* fl̗Lbit̃}XN */
#define PIX_MASK_R	(0xff << PIX_BIT_R)
#define PIX_MASK_G	(0xff << PIX_BIT_G)
#define PIX_MASK_B	(0xff << PIX_BIT_B)
#define PIX_MASK_A	(0xff << PIX_BIT_A)
#define PIX_MASK	(PIX_MASK_R | PIX_MASK_G | PIX_MASK_B)

/* fl <-> RGB */
#define PIX2R(pix)	(int )(((pix) >> PIX_BIT_R) & 0xff)
#define PIX2G(pix)	(int )(((pix) >> PIX_BIT_G) & 0xff)
#define PIX2B(pix)	(int )(((pix) >> PIX_BIT_B) & 0xff)
#define RGB2PIX(r, g, b)	(uint32 )((int )(r) << PIX_BIT_R | (int )(g) << PIX_BIT_G | (int )(b) << PIX_BIT_B)

/* fl <-> YIQ */
#define PIX2Y(pix)	RGB2Y(PIX2R(pix), PIX2G(pix), PIX2B(pix))
#define PIX2I(pix)	RGB2I(PIX2R(pix), PIX2G(pix), PIX2B(pix))
#define PIX2Q(pix)	RGB2Q(PIX2R(pix), PIX2G(pix), PIX2B(pix))
#define YIQ2PIX(y, i, q)	RGB2PIX(YIQ2R(y, i, q), YIQ2G(y, i, q), YIQ2B(y, i, q))
#define PIX2UI(pix)	(PIX2I(pix) + 128)
#define PIX2UQ(pix)	(PIX2Q(pix) + 128)
#define UYIQ2PIX(y, ui, uq)	YIQ2PIX(y, ui, uq)

/* fl <-> YUV */
#define PIX2U(pix)	RGB2U(PIX2R(pix), PIX2G(pix), PIX2B(pix))
#define PIX2V(pix)	RGB2V(PIX2R(pix), PIX2G(pix), PIX2B(pix))
#define YUV2PIX(y, u, v)	RGB2PIX(YUV2R(y, u, v), YUV2G(y, u, v), YUV2B(y, u, v))
#define PIX2UU(pix)	(PIX2U(pix) + 128)
#define PIX2UV(pix)	(PIX2V(pix) + 128)
#define UYUV2PIX(y, uu, uv)	YUV2PIX(y, uu, uv)

/* fl */
#define PIX_BLACK	RGB2PIX(0x00, 0x00, 0x00)	/*  */
#define PIX_RED	RGB2PIX(0xff, 0x00, 0x00)	/*  */
#define PIX_GREEN	RGB2PIX(0x00, 0xff, 0x00)	/*  */
#define PIX_YELLOW	RGB2PIX(0xff, 0xff, 0x00)	/*  */
#define PIX_BLUE	RGB2PIX(0x00, 0x00, 0xff)	/*  */
#define PIX_MAGENTA	RGB2PIX(0xff, 0x00, 0xff)	/* }[^ */
#define PIX_CYAN	RGB2PIX(0x00, 0xff, 0xff)	/* VA */
#define PIX_WHITE	RGB2PIX(0xff, 0xff, 0xff)	/*  */
#define PIX_DARKRED	RGB2PIX(0x88, 0x00, 0x00)	/* Â */
#define PIX_DARKGREEN	RGB2PIX(0x00, 0x88, 0x00)	/* Â */
#define PIX_DARKYELLOW	RGB2PIX(0x88, 0x88, 0x00)	/* Â */
#define PIX_DARKBLUE	RGB2PIX(0x00, 0x00, 0x88)	/* Â */
#define PIX_DARKMAGENTA	RGB2PIX(0x88, 0x00, 0x88)	/* Â}[^ */
#define PIX_DARKCYAN	RGB2PIX(0x00, 0x88, 0x88)	/* ÂVA */
#define PIX_GRAY	RGB2PIX(0x88, 0x88, 0x88)	/* D */

/*
	\
*/
/* AVIt@C */
typedef struct {
	MainAVIHeader avih;	/* Cwb_ */
	AVIStreamHeader strh;	/* Xg[wb_ */
	BITMAPINFOHEADER strf;	/* tH[}bg */
	RGBQUAD rgb[256];	/* J[e[u */
	AVIINDEXENTRY *idx;	/* CfNX */
	int fd;	/* t@CfBXNv^ */
	off_t off_avih;	/* Cwb_ ItZbg */
	off_t off_strh;	/* Xg[wb_ ItZbg */
	off_t off_strf;	/* tH[}bg ItZbg */
	off_t off_movi;	/* LIST'movi' ItZbg */
	DWORD size_movi;	/* LIST'movi' TCY */
	DWORD size_idx;	/* CfNX TCY */
	int is_written;	/* ܂ꂽ */
	uint32 nbuf;	/* CfNXobt@ */
} Avi;

/*
	֐vg^Cv
*/
/* ppm.c */
int ppmLoad(Image *, const char *);
int ppmtxtSave(Image, const char *);
int ppmbinSave(Image, const char *);

/* dib.c */
int readBYTE(int, void *, unsigned int);
int writeBYTE(int, const void *, unsigned int);
int readWORD(int, void *, unsigned int);
int writeWORD(int, const void *, unsigned int);
int readDWORD(int, void *, unsigned int);
int writeDWORD(int, const void *, unsigned int);
int dibReadHeader(int, BITMAPFILEHEADER *);
int dibWriteHeader(int, BITMAPFILEHEADER *);
int dibReadInfo(int, BITMAPINFOHEADER *);
int dibWriteInfo(int, BITMAPINFOHEADER *);
int dibReadRgb(int, RGBQUAD *, int);
int dibWriteRgb(int, RGBQUAD *, int);
int dibReadImage(int, Image *, BITMAPINFOHEADER, const RGBQUAD *);
int dibWriteImage(int, const Image *, BITMAPINFOHEADER);
int dibLoad(Image *, const char *);
int dibSave(Image, const char *);

/* avi.c */
void aviReadFrame(Avi *, Image *, int);
void aviWriteFrame(Avi *, const Image *, int);
Avi *aviWriteEmpty(int, Avi *, int, int, int);
Avi *aviOpen(const char *, int, ...);
Avi *aviClose(Avi *);

#endif

/* eof */
