/*
	ȈՉ摜Cu MicrosoftBitmapC[W(dib.c)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "image.h"
#include "depend.h"

#define HEADER_SIZE	14	/* t@Cwb_̑傫 */
#define INFO_SIZE	40	/* wb_̑傫 */
#define RGB_SIZE	4	/* J[e[ȗ傫 */

/* x 傫 y ̔{̍ŏl */
#define CEIL(x, y)	(((x) - 1) / (y) * (y) + (y))

/*
	O:
	 readBYTE  - 1oCgPʂœǂݍ
	 readBYTE  - 1oCgPʂŏ
	 readWORD  - 2oCgPʂŃgGfBȀœǂݍ
	 readWORD  - 2oCgPʂŃgGfBȀŏ
	 readDWORD - 4oCgPʂŃgGfBȀœǂݍ
	 readDWORD - 4oCgPʂŃgGfBȀŏ
*/
int readBYTE(int fd, void *buf, unsigned int n)
{
	return read(fd, buf, n);
}
int writeBYTE(int fd, const void *buf, unsigned int n)
{
	return write(fd, buf, n);
}
int readWORD(int fd, void *buf, unsigned int n)
{
#if defined(BYTEORDER_LITTLEENDIAN) || defined(BYTEORDER_PDPENDIAN)
	return read(fd, buf, n);
#elif defined(BYTEORDER_BIGENDIAN)
	int success;
	BYTE tmp, *p;

	success = read(fd, buf, n);
	for(p = (BYTE *)buf; p < (BYTE *)buf + n; p += 2) {
		tmp = *p; *p = *(p + 1); *(p + 1) = tmp;
	}
	return success;
#endif
}
int writeWORD(int fd, const void *buf, unsigned int n)
{
#if defined(BYTEORDER_LITTLEENDIAN) || defined(BYTEORDER_PDPENDIAN)
	return write(fd, buf, n);
#elif defined(BYTEORDER_BIGENDIAN)
	BYTE *p;

	for(p = (BYTE *)buf; p < (BYTE *)buf + n; p += 2) {
		if(write(fd, p + 1, 1) < 0)
			return -1;
		if(write(fd, p + 0, 1) < 0)
			return -1;
	}
	return n;
#endif
}
int readDWORD(int fd, void *buf, unsigned int n)
{
#if defined(BYTEORDER_LITTLEENDIAN)
	return read(fd, buf, n);
#else
	int success;
	BYTE tmp, *p;

	success = read(fd, buf, n);
	for(p = (BYTE *)buf; p < (BYTE *)buf + n; p += 4) {
	#if defined(BYTEORDER_BIGENDIAN)
		tmp = *p; *p = *(p + 3); *(p + 3) = tmp;
		tmp = *(p + 1); *(p + 1) = *(p + 2); *(p + 2) = tmp;
	#elif defined(BYTEORDER_PDPENDIAN)
		tmp = *p; *p = *(p + 1); *(p + 1) = tmp;
		tmp = *(p + 2); *(p + 2) = *(p + 3); *(p + 3) = tmp;
	#endif
	}
	return success;
#endif
}
int writeDWORD(int fd, const void *buf, unsigned int n)
{
#if defined(BYTEORDER_LITTLEENDIAN)
	return write(fd, buf, n);
#else
	BYTE *p;

	for(p = (BYTE *)buf; p < (BYTE *)buf + n; p += 4) {
	#if defined(BYTEORDER_BIGENDIAN)
		if(write(fd, p + 3, 1) < 0)
			return -1;
		if(write(fd, p + 2, 1) < 0)
			return -1;
		if(write(fd, p + 1, 1) < 0)
			return -1;
		if(write(fd, p + 0, 1) < 0)
			return -1;
	#elif defined(BYTEORDER_PDPENDIAN)
		if(write(fd, p + 1, 1) < 0)
			return -1;
		if(write(fd, p + 0, 1) < 0)
			return -1;
		if(write(fd, p + 3, 1) < 0)
			return -1;
		if(write(fd, p + 2, 1) < 0)
			return -1;
	#endif
	}
	return n;
#endif
}

/*
	J[/O[/2l摜̂ł邩
*/
#if 0
static int getType(const RGBQUAD *rgb, int bpp)
{
	int i;
	const RGBQUAD *p;

	if(bpp == 24 || bpp == 16)
		return IMG_COLOR;
	for(i = 0, p = rgb; p != rgb + (1 << bpp); i += 0xff >> (bpp - 1), p++)
		if(p->rgbRed != p->rgbGreen || p->rgbRed != p->rgbBlue)
			return IMG_COLOR;

	if(
	bpp == 1 && (
	(rgb[0].rgbRed == 0    && rgb[0].rgbGreen == 0    && rgb[0].rgbBlue == 0    && rgb[1].rgbRed == 0xff && rgb[1].rgbGreen == 0xff && rgb[1].rgbBlue == 0xff) ||
	(rgb[0].rgbRed == 0xff && rgb[0].rgbGreen == 0xff && rgb[0].rgbBlue == 0xff && rgb[1].rgbRed == 0    && rgb[1].rgbGreen == 0    && rgb[1].rgbBlue == 0)
	))
		return IMG_MONO;
	else
		return IMG_GRAY;
}
#endif

/*
	t@Cwb_ ǂݍ/
*/
#define DIB_RW_HEADER(rw, fd, header)\
	{\
		rw##BYTE(fd, &header->bfType, 2);\
		if(memcmp(&header->bfType, "BM", sizeof(header->bfType)) != 0)\
			return FALSE;\
		rw##DWORD(fd, &header->bfSize, 4);\
		rw##WORD(fd, &header->bfReserved1, 2);\
		rw##WORD(fd, &header->bfReserved2, 2);\
		rw##DWORD(fd, &header->bfOffBits, 4);\
		return TRUE;\
	}
int dibReadHeader(int fd, BITMAPFILEHEADER *header)
	DIB_RW_HEADER(read, fd, header)
int dibWriteHeader(int fd, BITMAPFILEHEADER *header)
	DIB_RW_HEADER(write, fd, header)

/*
	wb_ ǂݍ/
*/
#define DIB_RW_INFO(rw, fd, info)\
	{\
		rw##DWORD(fd, &info->biSize, 4);\
		rw##DWORD(fd, &info->biWidth, 4);\
		rw##DWORD(fd, &info->biHeight, 4);\
		rw##WORD(fd, &info->biPlanes, 2);\
		rw##WORD(fd, &info->biBitCount, 2);\
		rw##DWORD(fd, &info->biCompression, 4);\
		rw##DWORD(fd, &info->biSizeImage, 4);\
		rw##DWORD(fd, &info->biXPelsPerMeter, 4);\
		rw##DWORD(fd, &info->biYPelsPerMeter, 4);\
		rw##DWORD(fd, &info->biClrUsed, 4);\
		rw##DWORD(fd, &info->biClrImportant, 4);\
		return TRUE;\
	}
int dibReadInfo(int fd, BITMAPINFOHEADER *info)
	DIB_RW_INFO(read, fd, info)
int dibWriteInfo(int fd, BITMAPINFOHEADER *info)
	DIB_RW_INFO(write, fd, info)

/*
	J[e[u ǂݍ/
*/
#define DIB_RW_RGB(rw, fd, rgb, bpp)\
	{\
		RGBQUAD *p;\
		if(bpp != 24)\
			for(p = rgb; p != &rgb[1 << bpp]; p++) {\
				rw##BYTE(fd, &p->rgbBlue, 1);\
				rw##BYTE(fd, &p->rgbGreen, 1);\
				rw##BYTE(fd, &p->rgbRed, 1);\
				rw##BYTE(fd, &p->rgbReserved, 1);\
			}\
		return TRUE;\
	}
int dibReadRgb(int fd, RGBQUAD *rgb, int bpp)
	DIB_RW_RGB(read, fd, rgb, bpp)
int dibWriteRgb(int fd, RGBQUAD *rgb, int bpp)
	DIB_RW_RGB(write, fd, rgb, bpp)

/*
	RGB24/555/8/4/1 ǂݍ/
*/
static inline int dibReadDIB(int fd, Image *img, BITMAPINFOHEADER info, const RGBQUAD *rgb)
{
	const RGBQUAD *pal;
	int x, y, width, size_image;
	uint8 *buf, *p, *q;
	uint16 *r;

	imgAlloc(img, IMG_COLOR, info.biWidth, info.biHeight);
	width      = CEIL((info.biWidth * info.biBitCount), 4 * 8) / 8;
	size_image = width * info.biHeight * info.biBitCount;
	buf = malloc(size_image);
	read(fd, buf, size_image);

	switch(info.biBitCount) {
	case 24:
#ifdef IMAGE_BGR
		for(p = IMG_POINTER(*img, 0, img->height - 1), q = buf; p >= IMG_POINTER(*img, 0, 0); p -= img->size_width, q += width)
			memcpy(p, q, img->size_width);
#else
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x != img->width; x++, p += 3)
				psetc(*img, x, y, rgb2pix(p[2], p[1], p[0]));
#endif
		break;
	case 16:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, r = (uint16 *)q; x != img->width; x++, r += 2)
				psetc(*img, x, y, rgb2pix((*r & 0x001f) << 3, (*r & 0x03e0) >> 2, (*r & 0x7c00) >> 7));
		break;
	case 8:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x != img->width; x++, p++) {
				pal = &rgb[*p];
				psetc(*img, x, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
			}
		break;
	case 4:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x < img->width; x += 2, p++) {
				pal = &rgb[*p >> 4];
				psetc(*img, x + 0, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[*p & 0x0f];
				psetc(*img, x + 1, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
			}
		break;
	case 1:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x < img->width; x += 8, p++) {
				pal = &rgb[(*p >> 7) & 1];
				psetc(*img, x + 0, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 6) & 1];
				psetc(*img, x + 1, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 5) & 1];
				psetc(*img, x + 2, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 4) & 1];
				psetc(*img, x + 3, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 3) & 1];
				psetc(*img, x + 4, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 2) & 1];
				psetc(*img, x + 5, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 1) & 1];
				psetc(*img, x + 6, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
				pal = &rgb[(*p >> 0) & 1];
				psetc(*img, x + 7, y, rgb2pix(pal->rgbRed, pal->rgbGreen, pal->rgbBlue));
			}
		break;
	default:
		free(buf);
		return FALSE;
	}

	free(buf);
	return TRUE;
}
static int inline dibWriteDIB(int fd, const Image *img, BITMAPINFOHEADER info, RGBQUAD *dummy)
{
	int x, y, width;
	uint32 pix;
	uint8 *buf = malloc(info.biSizeImage), *p, *q;

	width = CEIL((info.biWidth * info.biBitCount), 4 * 8) / 8;

	switch(info.biBitCount) {
	case 24:
/*
#ifdef IMAGE_BGR
		for(p = buf, q = IMG_POINTER(*img, 0, img->height - 1); q >= IMG_POINTER(*img, 0, 0); p += width, q -= img->size_width)
			memcpy(p, q, img->size_width);
#else
*/
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x != img->width; x++, p += 3) {
				pix = pointc(*img, x, y);
				p[0] = pix2b(pix);
				p[1] = pix2g(pix);
				p[2] = pix2r(pix);
			}
/*
#endif
*/
		break;
	case 8:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x != img->width; x++, p++)
				*p = pointg(*img, x, y);
		break;
	case 1:
		for(y = img->height - 1, q = buf; y >= 0; y--, q += width)
			for(x = 0, p = q; x < img->width; x += 8, p++) {
				*p = (pointm(*img, x + 0, y) << 7) |
				     (pointm(*img, x + 1, y) << 6) |
				     (pointm(*img, x + 2, y) << 5) |
				     (pointm(*img, x + 3, y) << 4) |
				     (pointm(*img, x + 4, y) << 3) |
				     (pointm(*img, x + 5, y) << 2) |
				     (pointm(*img, x + 6, y) << 1) |
				     (pointm(*img, x + 7, y) << 0);
			}
		break;
	default:
		free(buf);
		return FALSE;
	}

	write(fd, buf, info.biSizeImage);
	free(buf);
	return TRUE;
}

/*
	BrooktreeYUV411Raw(Y41P)C[W ǂݍ/
*/
static int inline dibReadY41P(int fd, Image *img, BITMAPINFOHEADER info)
{
	int u, v, x, y;
	uint8 *buf = malloc(info.biSizeImage), *p;

	imgAlloc(img, IMG_COLOR, info.biWidth, info.biHeight);
	read(fd, buf, info.biSizeImage);

	p = buf;
	for(y = img->height - 1; y >= 0; y--)
		for(x = 0; x < img->width; x += 8) {
			u = (int )*p       - 128;
			v = (int )*(p + 2) - 128;
			psetc(*img, x    , y, yuv2pix(*(p + 1), u, v));
			psetc(*img, x + 1, y, yuv2pix(*(p + 3), u, v));
			psetc(*img, x + 2, y, yuv2pix(*(p + 5), u, v));
			psetc(*img, x + 3, y, yuv2pix(*(p + 7), u, v));

			u = (int )*(p + 4) - 128;
			v = (int )*(p + 6) - 128;
			psetc(*img, x + 4, y, yuv2pix(*(p +  8), u, v));
			psetc(*img, x + 5, y, yuv2pix(*(p +  9), u, v));
			psetc(*img, x + 6, y, yuv2pix(*(p + 10), u, v));
			psetc(*img, x + 7, y, yuv2pix(*(p + 11), u, v));

			p += 12;
		}

	free(buf);

	return TRUE;
}
static int inline dibWriteY41P(int fd, const Image *img, BITMAPINFOHEADER info)
{
	int x, y;
	uint8 *buf = malloc(info.biSizeImage), *p;

	p = buf;
	for(y = img->height - 1; y >= 0; y--)
		for(x = 0; x < img->width; x += 8) {
			*p++ = pix2u(pointc(*img, x    , y)) + 128;
			*p++ = pix2y(pointc(*img, x    , y));
			*p++ = pix2v(pointc(*img, x    , y)) + 128;
			*p++ = pix2y(pointc(*img, x + 1, y));
			*p++ = pix2u(pointc(*img, x + 4, y)) + 128;
			*p++ = pix2y(pointc(*img, x + 2, y));
			*p++ = pix2v(pointc(*img, x + 4, y)) + 128;
			*p++ = pix2y(pointc(*img, x + 3, y));
			*p++ = pix2y(pointc(*img, x + 4, y));
			*p++ = pix2y(pointc(*img, x + 5, y));
			*p++ = pix2y(pointc(*img, x + 6, y));
			*p++ = pix2y(pointc(*img, x + 7, y));
		}

	write(fd, buf, info.biSizeImage);

	free(buf);

	return TRUE;
}

/*
	YUY2C[W ǂݍ/
*/
static int inline dibReadYUY2(int fd, Image *img, BITMAPINFOHEADER info)
{
	int u, v, x, y;
	uint8 *buf = malloc(info.biSizeImage), *p;

	imgAlloc(img, IMG_COLOR, info.biWidth, info.biHeight);
	read(fd, buf, info.biSizeImage);

	p = buf;
	for(y = 0; y != img->height; y++)
		for(x = 0; x < img->width; x += 2) {
			u = (int )*(p + 1) - 128;
			v = (int )*(p + 3) - 128;
			psetc(*img, x    , y, yuv2pix(*p      , u, v));
			psetc(*img, x + 1, y, yuv2pix(*(p + 2), u, v));

			p += 4;
		}

	free(buf);

	return TRUE;
}
static int inline dibWriteYUY2(int fd, const Image *img, BITMAPINFOHEADER info)
{
	int x, y;
	uint8 *buf = malloc(info.biSizeImage), *p;

	p = buf;
	for(y = 0; y != img->height; y++)
		for(x = 0; x < img->width; x += 2) {
			*p++ = pix2y(pointc(*img, x    , y));
			*p++ = pix2u(pointc(*img, x    , y)) + 128;
			*p++ = pix2y(pointc(*img, x + 1, y));
			*p++ = pix2v(pointc(*img, x    , y)) + 128;
		}

	write(fd, buf, info.biSizeImage);

	free(buf);
	
	return TRUE;
}

/*
	YV12C[W ǂݍ/
*/
static int inline dibReadYV12(int fd, Image *img, BITMAPINFOHEADER info)
{
	int u, v, x, y;
	uint8 *buf = malloc(info.biSizeImage), *p, *q, *r, *s;

	imgAlloc(img, IMG_COLOR, info.biWidth, info.biHeight);
	read(fd, buf, info.biSizeImage);

	r = buf + info.biWidth * info.biHeight;
	s = r + info.biWidth * info.biHeight / 4;
	for(y = 0, p = buf; y < img->height; y += 2, p += info.biWidth * 2) {
		for(x = 0, q = p; x < img->width; x += 2, q += 2) {
			u = (int )*r - 128;
			v = (int )*s - 128;
			psetc(*img, x    , y    , yuv2pix(*q                     , u, v));
			psetc(*img, x + 1, y    , yuv2pix(*(q + 1)               , u, v));
			psetc(*img, x    , y + 1, yuv2pix(*(q + info.biWidth)    , u, v));
			psetc(*img, x + 1, y + 1, yuv2pix(*(q + info.biWidth + 1), u, v));

			r++;
			s++;
		}
	}

	free(buf);

	return TRUE;
}
static int inline dibWriteYV12(int fd, const Image *img, BITMAPINFOHEADER info)
{
	return FALSE;
}

/*
	YVU9C[W ǂݍ/
*/
static int inline dibReadYVU9(int fd, Image *img, BITMAPINFOHEADER info)
{
	int u, v, x, y;
	uint8 *buf = malloc(info.biSizeImage), *p, *q, *r, *s;

	imgAlloc(img, IMG_COLOR, info.biWidth, info.biHeight);
	read(fd, buf, info.biSizeImage);

	r = buf + info.biWidth * info.biHeight;
	s = r + info.biWidth * info.biHeight / 16;
	for(y = 0, p = buf; y < img->height; y += 4, p += info.biWidth * 4) {
		for(x = 0, q = p; x < img->width; x += 4, q += 4) {
			v = (int )*r - 128;
			u = (int )*s - 128;
			psetc(*img, x    , y    , yuv2pix(*q                         , u, v));
			psetc(*img, x + 1, y    , yuv2pix(*(q + 1)                   , u, v));
			psetc(*img, x + 2, y    , yuv2pix(*(q + 2)                   , u, v));
			psetc(*img, x + 3, y    , yuv2pix(*(q + 3)                   , u, v));
			psetc(*img, x    , y + 1, yuv2pix(*(q + info.biWidth)        , u, v));
			psetc(*img, x + 1, y + 1, yuv2pix(*(q + info.biWidth + 1)    , u, v));
			psetc(*img, x + 2, y + 1, yuv2pix(*(q + info.biWidth + 2)    , u, v));
			psetc(*img, x + 3, y + 1, yuv2pix(*(q + info.biWidth + 3)    , u, v));
			psetc(*img, x    , y + 2, yuv2pix(*(q + info.biWidth * 2)    , u, v));
			psetc(*img, x + 1, y + 2, yuv2pix(*(q + info.biWidth * 2 + 1), u, v));
			psetc(*img, x + 2, y + 2, yuv2pix(*(q + info.biWidth * 2 + 2), u, v));
			psetc(*img, x + 3, y + 2, yuv2pix(*(q + info.biWidth * 2 + 3), u, v));
			psetc(*img, x    , y + 3, yuv2pix(*(q + info.biWidth * 3)    , u, v));
			psetc(*img, x + 1, y + 3, yuv2pix(*(q + info.biWidth * 3 + 1), u, v));
			psetc(*img, x + 2, y + 3, yuv2pix(*(q + info.biWidth * 3 + 2), u, v));
			psetc(*img, x + 3, y + 3, yuv2pix(*(q + info.biWidth * 3 + 3), u, v));

			r++;
			s++;
		}
	}

	free(buf);

	return TRUE;
}
static int inline dibWriteYVU9(int fd, const Image *img, BITMAPINFOHEADER info)
{
	return FALSE;
}

/*
	C[W ǂݍ/
*/
#define DIB_RW_IMAGE(rw, fd, img, info, rgb)\
	{\
		if(info.biCompression == *(DWORD *)"DIB " || info.biCompression == *(DWORD *)"\0\0\0\0")\
			return dib##rw##DIB(fd, img, info, rgb);\
		else if(info.biCompression == *(DWORD *)"Y41P")\
			return dib##rw##Y41P(fd, img, info);\
		else if(info.biCompression == *(DWORD *)"YUY2")\
			return dib##rw##YUY2(fd, img, info);\
		else if(info.biCompression == *(DWORD *)"YV12" || info.biCompression == *(DWORD *)"I420")\
			return dib##rw##YV12(fd, img, info);\
		else if(info.biCompression == *(DWORD *)"YVU9")\
			return dib##rw##YVU9(fd, img, info);\
		else\
			return FALSE;\
	}
		
int dibReadImage(int fd, Image *img, BITMAPINFOHEADER info, const RGBQUAD *rgb)
	DIB_RW_IMAGE(Read, fd, img, info, rgb)
int dibWriteImage(int fd, const Image *img, BITMAPINFOHEADER info)
	DIB_RW_IMAGE(Write, fd, img, info, NULL)

/*
	DIBC[W [h
*/
int dibLoad(Image *img, const char *file)
{
	BITMAPFILEHEADER header;
	BITMAPINFOHEADER info;
	RGBQUAD rgb[256];
	int fd;

	if((fd = open(file, O_RDONLY | O_BINARY)) == -1)
		return FALSE;
	if(!dibReadHeader(fd, &header))
		return FALSE;
	dibReadInfo(fd, &info);
	dibReadRgb(fd, rgb, info.biBitCount);
	lseek(fd, header.bfOffBits, SEEK_SET);
	dibReadImage(fd, img, info, rgb);
	close(fd);

	return TRUE;
}

/*
	DIBC[W Z[u
*/
int dibSave(Image img, const char *file)
{
	BITMAPFILEHEADER header;
	BITMAPINFOHEADER info;
	RGBQUAD rgb[256];
	int bpp, fd, i, j, n_dibrgb;

	bpp = (img.type == IMG_COLOR ? 24: (img.type == IMG_GRAY ? 8: 1));

	/* t@Cwb_ */
	n_dibrgb = (bpp <= 8 ? 1U << bpp: 0);
	memcpy(&header.bfType, "BM", sizeof(header.bfType));
	header.bfSize      = HEADER_SIZE + INFO_SIZE + RGB_SIZE * n_dibrgb + img.width * img.height * bpp / 8;
	header.bfReserved1 = 0;
	header.bfReserved2 = 0;
	header.bfOffBits   = HEADER_SIZE + INFO_SIZE + RGB_SIZE * n_dibrgb;

	/* wb_ */
	info.biSize          = INFO_SIZE;
	info.biWidth         = img.width;
	info.biHeight        = img.height;
	info.biPlanes        = 1;
	info.biBitCount      = bpp;
	info.biCompression   = 0;
	info.biSizeImage     = CEIL(info.biWidth, 4 * 8) / 8 * info.biHeight * info.biBitCount;
	info.biXPelsPerMeter = 3780;
	info.biYPelsPerMeter = 3780;
	info.biClrUsed       = 0;
	info.biClrImportant  = 0;

	/* J[e[u */
	if(bpp <= 8)
		for(i = 0, j = 0; i < 0x100; i += (0xff >> (bpp - 1)), j++) {
			rgb[j].rgbRed = rgb[j].rgbGreen = rgb[j].rgbBlue = i;
			rgb[j].rgbReserved = 0;
		}

	/*  */
	if((fd = open(file, O_CREAT | O_TRUNC | O_WRONLY | O_BINARY, 0664)) == -1)
		return FALSE;
	dibWriteHeader(fd, &header);
	dibWriteInfo(fd, &info);
	dibWriteRgb(fd, rgb, info.biBitCount);
	dibWriteImage(fd, &img, info);
	close(fd);

	return TRUE;
}

/* eof */
