/*
	ȈՉ摜Cu wb_(image.h)
*/

#ifndef IMAGE_H
#define IMAGE_H

#include <stdio.h>
#include <limits.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

/*
	ˑ
*/
#if !defined(UINT8_MAX)
#define UINT8_MAX	UCHAR_MAX
#endif
#if !defined(UINT8_MIN)
#define UINT8_MIN	UCHAR_MIN
#endif
#if !defined(INT8_MAX)
#define INT8_MAX	CHAR_MAX
#endif
#if !defined(INT8_MIN)
#define INT8_MIN	CHAR_MIN
#endif
#if !defined(UINT16_MAX)
#define UINT16_MAX	USHRT_MAX
#endif
#if !defined(UINT16_MIN)
#define UINT16_MIN	USHRT_MIN
#endif
#if !defined(INT16_MAX)
#define INT16_MAX	SHRT_MAX
#endif
#if !defined(INT16_MIN)
#define INT16_MIN	SHRT_MIN
#endif
#if !defined(UINT32_MAX)
#define UINT32_MAX	UINT_MAX
#endif
#if !defined(UINT32_MIN)
#define UINT32_MIN	UINT_MIN
#endif
#if !defined(INT32_MAX)
#define INT32_MAX	INT_MAX
#endif
#if !defined(INT32_MIN)
#define INT32_MIN	INT_MIN
#endif
typedef unsigned char	uint8;	/* Ȃ8bits */
typedef char	int8;	/* 8bits */
typedef unsigned short	uint16;	/* Ȃ16bits */
typedef short	int16;	/* 16bits */
typedef unsigned int	uint32;	/* Ȃ32bits */
typedef int	int32;	/* 32bits */

#ifdef USE_VIDEO4LINUX
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/videodev.h>
#define V_MAXFRAME	VIDEO_MAX_FRAME	/* őt[ */
#else
#define V_MAXFRAME	0
#endif

/*
	}N
*/
/* null摜 */
#define IMG_NULL	{ 0, 0, 0, 0, 0, 0, NULL, NULL }

/* 摜` */
#define IMG_PXMBIN	0	/* ppm/pgm/pbmoCi` */
#define IMG_PXMTXT	1	/* ppm/pgm/pbmeLXg` */
#define IMG_BITMAP	2	/* MicrosoftBitmap` */

/* I[v */
#define MOV_READ	O_RDONLY
#define MOV_WRITE	O_RDWR
#define MOV_CREATE	(O_CREAT | O_RDWR | O_TRUNC)
#define MOV_CREAT	MOV_CREATE

/* G[ */
#define IMGERR_NONE	0
#define IMGERR_NO_MEMORY	1
#define IMGERR_WRONG_IMAGE	2
#define IMGERR_CANNOT_LOAD	3
#define IMGERR_CANNOT_SAVE	4
#define IMGERR_UNSUPPORTED	5
#define IMGERR_LAST	5

/*
	}N֐
*/
/* RGB <-> YIQ */
#define RGB2Y(r, g, b)	(((int )(r) * 299 + (int )(g) * 587 + (int )(b) * 114) / 1000)
#define RGB2I(r, g, b)	(((int )(r) * 596 - (int )(g) * 275 - (int )(b) * 321) / 1000)
#define RGB2Q(r, g, b)	(((int )(r) * 212 - (int )(g) * 523 + (int )(b) * 311) / 1000)
#define YIQ2R(y, i, q)	(((int )(y) * 1000 + (int )(i) *  956 + (int )(q) *  621) / 1000)
#define YIQ2G(y, i, q)	(((int )(y) * 1000 - (int )(i) *  272 - (int )(q) *  647) / 1000)
#define YIQ2B(y, i, q)	(((int )(y) * 1000 - (int )(i) * 1105 + (int )(q) * 1702) / 1000)
#define RGB2UI(r, g, b)	(RGB2I(r, g, b) + 128)
#define RGB2UQ(r, g, b)	(RGB2Q(r, g, b) + 128)
#define UYIQ2R(y, ui, uq)	YIQ2R(y, (int )(ui) - 128, (int )(uq) - 128)
#define UYIQ2G(y, ui, uq)	YIQ2G(y, (int )(ui) - 128, (int )(uq) - 128)
#define UYIQ2B(y, ui, uq)	YIQ2B(y, (int )(ui) - 128, (int )(uq) - 128)

/* RGB <-> YUV */
#define RGB2U(r, g, b)	((-(int )(r) * 168 - (int )(g) * 332 + (int )(b) * 500) / 1000)
#define RGB2V(r, g, b)	(( (int )(r) * 500 - (int )(g) * 419 - (int )(b) *  81) / 1000)
#define YUV2R(y, u, v)	(((int )(y) * 1000                    + (int )(v) * 1402) / 1000)
#define YUV2G(y, u, v)	(((int )(y) * 1000 - (int )(u) *  344 - (int )(v) *  714) / 1000)
#define YUV2B(y, u, v)	(((int )(y) * 1000 + (int )(u) * 1772                   ) / 1000)
#define RGB2UU(r, g, b)	(RGB2U(r, g, b) + 128)
#define RGB2UV(r, g, b)	(RGB2V(r, g, b) + 128)
#define UYUV2R(y, uu, uv)	YUV2R(y, (int )(uu) - 128, (int )(uv) - 128)
#define UYUV2G(y, uu, uv)	YUV2G(y, (int )(uu) - 128, (int )(uv) - 128)
#define UYUV2B(y, uu, uv)	YUV2B(y, (int )(uu) - 128, (int )(uv) - 128)

/* C[W̕byte */
#define IMG_SIZE_WIDTH(img)	(((img).width * (img).bpp + 7) / 8)

/* C[Wbyte */
#define IMG_SIZE(img)	(IMG_SIZE_WIDTH(img) * (img).height + 1)

/* C[W̃AhX */
#define IMG_POINTER(img, x, y)	((img).image + (img).size_width * (y) + (x) * (img).bpp / 8)

/* Null摜ł邩 */
#define IMG_IS_NULL(img)	((img).image == NULL)

/* XN[̊Oł邩 */
#define IMG_IS_OUTSIDE(img, x, y)	((x) < 0 || (x) >= (img).width || (y) < 0 || (y) >= (img).height)

/*
	\
*/
/* 摜 */
typedef struct {
	int type;	/* 摜 */
#define IMG_MONO	1	/* 2l */
#define IMG_GRAY	2	/* O[XP[ */
#define IMG_COLOR	3	/* J[ */
	int bpp;	/* 1fbit */
	int width;	/* 摜̉f */
	int height;	/* 摜̏cf */
	size_t size;	/* 摜byte */
	size_t size_width;	/* 摜̕byte */
	uint8 *image;	/* C[Wւ̃|C^ */
#ifdef USE_X
	XImage *x;
#else
	void *x;
#endif
} Image;

/* rfILv` */
typedef struct {
#ifdef USE_VIDEO4LINUX
	Image frame[V_MAXFRAME];	/* t[ */
	int fd;	/* /dev/video */
	char *map;	/* mۂꂽ */
	struct video_capability cap;
	struct video_channel ch;
	struct video_picture pic;
	struct video_mbuf mbuf;
	struct video_mmap mmap;
#else
	int dummy;
#endif
} Capture;

/*  */
typedef struct {
	int nbuf;	/* t[obt@ */
	int n;	/* ݂̃t[ */
	int format;	/* ` */
#define MOV_IMAGES	1	/* A摜() */
#define MOV_AVI	2	/* AVI` */
#define MOV_CAPTURE	3	/* rfILv` */
	Image *frame;	/* frameobt@ */
	void *fmt;
} Movie;

/* ` */
typedef struct {
	int x;	/* xW */
	int y;	/* yW */
	int width;	/*  */
	int height;	/*  */
} Rect;

/* p[^ */
typedef struct {
	int mono;	/* 2l臒l */
	int smooth;	/* gkɃX[WO邩? */
	int exit_when_error;	/* G[ɏI邩? */
	char *pathRGB;	/* rgb.txt̃pX */
} Imgparam;

/*
	O[oϐ
*/
extern const Image imgNull;
extern Imgparam imgParam;

/*
	֐vg^Cv
*/
/* image.c */
int imgIsWrong(Image);
int imgIsNull(Image);
int imgIsOutside(Image, int, int);
int imgGetError(void);
const char *imgGetErrorText(void);
void imgSetError(int);
int imgAlloc0(Image *, int, int, int, int);
void imgFree(Image *);
int imgAlloc(Image *, int, int, int);
int imgRAlloc(Image *, Image *, int, int, int);
void imgFreeTmp(void);
int imgLoad(Image *, const char *);
int imgLoadConv(Image *, const char *, int, int, int);
int imgSave(Image, const char *, int);
int imgSaveSuf(Image, const char *, int);
void imgInfo(FILE *, Image);

/* color.c */
int pix2r(uint32);
int pix2g(uint32);
int pix2b(uint32);
uint32 rgb2pix(int, int, int);
int rgb2y(int, int, int);
int rgb2i(int, int, int);
int rgb2q(int, int, int);
int yiq2r(int, int, int);
int yiq2g(int, int, int);
int yiq2b(int, int, int);
int pix2y(uint32);
int pix2i(uint32);
int pix2q(uint32);
uint32 yiq2pix(int, int, int);
int rgb2ui(int, int, int);
int rgb2uq(int, int, int);
int uyiq2r(int, int, int);
int uyiq2g(int, int, int);
int uyiq2b(int, int, int);
int pix2ui(uint32);
int pix2uq(uint32);
uint32 uyiq2pix(int, int, int);
int rgb2u(int, int, int);
int rgb2v(int, int, int);
int yuv2r(int, int, int);
int yuv2g(int, int, int);
int yuv2b(int, int, int);
int pix2u(uint32);
int pix2v(uint32);
uint32 yuv2pix(int, int, int);
int rgb2uu(int, int, int);
int rgb2uv(int, int, int);
int uyuv2r(int, int, int);
int uyuv2g(int, int, int);
int uyuv2b(int, int, int);
int pix2uu(uint32);
int pix2uv(uint32);
uint32 uyuv2pix(int, int, int);
int rgb2hsv_h(int, int, int);
int rgb2hsv_s(int, int, int);
int rgb2hsv_v(int, int, int);
int hsv2r(int, int, int);
int hsv2g(int, int, int);
int hsv2b(int, int, int);
int pix2hsv_h(uint32);
int pix2hsv_s(uint32);
int pix2hsv_v(uint32);
uint32 hsv2pix(int, int, int);
uint32 num2pix(int);
int pix2num(uint32);
char *pix2name(char *, uint32);
uint32 name2pix(const char *);

/* draw.c */
int pointm(Image, int, int);
int pointg(Image, int, int);
uint32 pointc(Image, int, int);
void psetm(Image, int, int, int);
void psetg(Image, int, int, int);
void psetc(Image, int, int, uint32);
void imgClear(Image, uint32);
void imgPaint(Image, int, int, uint32, uint32);

/* edit.c */
void imgCopy(Image *, Image);
void imgCopyArea(Image, int, int, Image, int, int, int, int);
void imgCopyAreaR(Image, Rect, Image, Rect);
void imgMoveArea(Image, int, int, Image, int, int, int, int);
void imgMoveAreaR(Image, Rect, Image, Rect);
void imgAllocCopyArea(Image *, Image, int, int, int, int);
void imgAllocCopyAreaR(Image *, Image, Rect);
void imgResize(Image *, Image, int, int);
void imgZoom(Image *, Image, int, int, int);
void imgInv(Image *, Image);
void imgConv(Image *, Image, int, ...);
void imgMirror(Image *, Image, int, int);
void imgRotate(Image *, Image, int);
int imgColors(Image, uint32 *, int *, int);
void imgMaskColor(Image *, Image, uint32[], int);

/* movie.c */
int movUsecPerFrame(const Movie *);
int movFrames(const Movie *);
int movFpks(const Movie *);
int movFps(const Movie *);
void movReadFrame(Movie *, Image *, int);
void movWriteFrame(Movie *, const Image *, int);
Image movSetFrame(Movie *, int);
Image movNextFrame(Movie *);
Image movPrevFrame(Movie *);
Image movMoveFrame(Movie *, int);
void movFlushFrame(Movie *);
Movie *movOpen(const char *, int, int, ...);
Movie *movClose(Movie *);

/* capture.c */
#ifdef USE_VIDEO4LINUX
int capChannel(Capture *, int);
int capPicture(Capture *, int, int, int, int, int);
int capMap(Capture *, int, int, int);
int capCapture(Capture *, int);
int capSync(Capture *, int);
void capReadFrame(Capture *, Image *);
Capture *capOpen(const char *, int, int, int, int);
Capture *capClose(Capture *);
#else
#define capChannel(cap, n)	-1
#define capPicture(cap, whiteness, contrast, colour, hue, brightness)	-1
#define capMap(cap, type, width, height)	-1
#define capCapture(cap, n)	-1
#define capSynv(cap, n)	-1
#define capReadFrame(cap, frame)	imgNull
#define capOpen(devname, ch, type, width, height)	NULL
#define capClose(cap)	NULL
#endif

/* filter.c */
void imgSpaFilter(Image *, Image, const int *, int, int, int);
void imgLaplacian4(Image *, Image);
void imgLaplacian8(Image *, Image);
void imgSmooth(Image *, Image, int);
void imgBlur(Image *, Image, int, int);
void imgMedFilter(Image *, Image, int, int);

/* mono.c */
void imgErode(Image *, Image, int, int);
void imgDilate(Image *, Image, int, int);
void imgMask(Image *, Image, Image, int);
int imgGetLabel(Image, int, int);
void imgSetLabel(Image, int, int, int);
int imgLabeling(Image *, Image);
void imgMaskLabel(Image *, Image, Image, int, int);
void imgRemoveNoiseMono(Image *, Image, int);

#endif

/* eof */
