#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "image.h"

#define FALSE	0
#define TRUE	1

static int getValue(Image img, int x, int y)
{
	int v = pointg(img, x, y);

	if(v < 64)
		return 3;
	else if(v < 160)
		return 2;
	else if(v < 224)
		return 1;
	else
		return 0;
}

static unsigned char getByte(Image img, int x, int y, int plane)
{
	int mask = (plane ? 1: 2);

	return
	(getValue(img, x, y + 0) & mask ? 0x01: 0) |
	(getValue(img, x, y + 1) & mask ? 0x02: 0) |
	(getValue(img, x, y + 2) & mask ? 0x04: 0) |
	(getValue(img, x, y + 3) & mask ? 0x08: 0) |
	(getValue(img, x, y + 4) & mask ? 0x10: 0) |
	(getValue(img, x, y + 5) & mask ? 0x20: 0) |
	(getValue(img, x, y + 6) & mask ? 0x40: 0) |
	(getValue(img, x, y + 7) & mask ? 0x80: 0);
}

int main(int argc, char *argv[])
{
	Image img = IMG_NULL;
	int x, y, plane, gray;

	imgLoadConv(&img, argv[1], IMG_GRAY, 0, 0);

	printf("%s::\n", argv[2]);

	for(y = 0; y < img.height; y += 8) {
		gray = FALSE;
		for(x = 0; x < img.width; x++)
			if(getByte(img, x, y, 0) != getByte(img, x, y, 1)) {
				gray = TRUE;
				break;
			}
	
		printf("\t.db 0x%02x\n", img.width / 6 | (gray ? 0x00: 0x80));

		for(x = 0; x < img.width; x += 6)
			for(plane = 0; plane < (gray ? 2: 1); plane++) {
				printf("\t.db 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x, 0x%02x\n",
				getByte(img, x + 0, y, plane),
				getByte(img, x + 1, y, plane),
				getByte(img, x + 2, y, plane),
				getByte(img, x + 3, y, plane),
				getByte(img, x + 4, y, plane),
				getByte(img, x + 5, y, plane)
				);
			}
	}

	return 0;
}

/* eof */
